#ifndef _PBC_NXX_2D
#define _PBC_NXX_2D

#include "mesh.h"
#include "rectangularmesh.h"
#include "demagcoef.h"
#include "pbc_util.h"

class NXXPBC{
  private:
  mutable UINT4m xdim, ydim, zdim; // natural size
  mutable UINT4m xydim;
  mutable UINT4m totalsize;
    // relative cell edge sizes
  mutable REALWIDE dx, dy, dz;

  mutable REALWIDE error;
    
  mutable double *Nxx,*Nyy,*Nzz,*Nxy,*Nxz,*Nyz;
  
  mutable int Lcx,Lcy;

  String load_file_name,save_file_name;
  
  int getOrder(int i,int j,int k) const; 
  double Sum(int n,double *array) const;

  bool LoadNXX(const String soure);
  void SaveNXX(const String target);
  void ReleaseMemory() const;

  int FindG(enum Type_Nij type,double v,double Tx,double Ty) const;
  
  public:
	NXXPBC(const string in_load_file_name,
			 const string in_save_file_name,
			 int in_xdim,int in_ydim,int in_zdim,
			 double in_dx,double in_dy,double in_dz,
             double error);
	void CalcNXX();
	double getNXX(enum Type_Nij type,int i,int j,int k);
	~NXXPBC(){ ReleaseMemory(); }
};



#endif 
